//Draw stuff!

var font = new Font();

var white = new Color(255,255,255);
var black = new Color(0,0,0);
var grey = new Color(200,200,200);
var transparent = new Color(0, 0, 0, 0);
var color = black;

var buttonDark = new Color(128,128,128);
var buttonLight = new Color(240,240,240);

function game()
{
	var drawx;
	var drawy;
	
	font.setColorMask(black);
	var surface = new Surface(540, 480, white);
	var mouse = new Image("mouse.png");
	
	//Buttons
	var buttons = [];
	buttons[0] = new Button(10, 10, 50, 20, "Dot");
	
	//Tools
	var dot = new Surface(10, 10, transparent);
	dot.filledCircle(5, 5, 5, black, true);
	
	Screen.framerate = 60;
	
	while(true)
	{
		drawx = Input.mouse.x-100;
		drawy = Input.mouse.y;
		
		Screen.blit(surface, 100, 0);
		Screen.filledRectangle(0, 0, 98, Screen.height, grey);
		
		for (var i = 0, len = buttons.length; i < len; i++)
			buttons[i].draw();
		
		Screen.blit(mouse, Input.mouse.x, Input.mouse.y);
		Screen.flip();
		
		
		/*** MOUSE ACTIONS ***/
		if (Input.mouse.buttons[MOUSE_LEFT])
		{
			//surface.blit(dot, Input.mouse.x, Input.mouse.y);
			surface.blitSurface(dot, drawx-5, drawy-5);
		}
		
		
		/*** KEYS ***/
		if (Input.keyboard.keys[KEY_ESCAPE])
		{
			//Menu?
			Sphere.exit();
		}
	}
}




/***********************
   BUTTONS AND LABELS
***********************/



function Button(x, y, width, height, text)
{
	this.x = x;
	this.y = y;
	this.width = width;
	this.height = height;
	this.text = text;
	
	this.draw = function()
	{
		Screen.line(this.x, this.y, this.x+this.width, this.y, buttonLight);
		Screen.line(this.x, this.y, this.x, this.y+this.height, buttonLight);
		Screen.line(this.x+this.width, this.y, this.x+this.width, this.y+this.height, buttonDark);
		Screen.line(this.x, this.y+this.height, this.x+this.width, this.y+this.height, buttonDark);
		Screen.textBox(font, this.x+2, this.y+4, this.width-2, this.height-4, 0, text);
	}
	
	this.pressedDraw = function()
	{
		Screen.line(this.x, this.y, this.x+this.width, this.y, buttonDark);
		Screen.line(this.x, this.y, this.x, this.y+this.height, buttonDark);
		Screen.line(this.x+this.width, this.y, this.x+this.width, this.y+this.height, buttonLight);
		Screen.line(this.x, this.y+this.height, this.x+this.width, this.y+this.height, buttonLight);
		Screen.textBox(font, this.x+2, this.y+4, this.width-2, this.height-4, 0, text);
	}
	
	this.pressed = function()
	{
		if (Input.mouse.x > this.x && Input.mouse.x < this.x+this.width);
	}
}